/* Copyright (c) 2006-2007 Christopher J. W. Lloyd

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. */

#import <GlyphsCore/GSBase.h>

@class NSMutableData, NSData;

// void encodePropertyList(id plist, CFMutableDataRef data, BOOL escape);
//-(NSData*)dataForRootObject:object;

NSData *nullTerminatedASCIIDataWithString(NSString *string);

NSData *nullTerminatedASCIIDataWithPropertyList(id plist);

NSData *dataWithPropertyList(id plist, GSFormatVersion format, NSError **error);

NSString *stringWithPropertyList(id plist, GSFormatVersion format, NSError **error);

NSString *stringWithPropertyListNoEscape(id plist, GSFormatVersion format, NSError **error);

BOOL writePropertyListToFile(FILE *file, id plist, GSFormatVersion format, NSError **error);

BOOL writePropertyListToFileNoEscape(FILE *file, id plist, GSFormatVersion format, NSError **error);

BOOL GSEncodeArray(NSArray *array, CFMutableDataRef data, BOOL escape, GSFormatVersion format, NSError **error);
void GSEncodeString(NSString *string, CFMutableDataRef data, BOOL escape);
void GSEncodePoint(NSPoint point, CFMutableDataRef data, GSFormatVersion format);
void GSEncodeFloat(CGFloat Float, CFMutableDataRef data);
void GSEncodeColor(NSColor *color, CFMutableDataRef data, GSFormatVersion format);

NSMutableDictionary *GSFlattenDictionary(NSDictionary *dictionary, GSFormatVersion format, NSError **error);

NSArray *GSFlattenArray(NSArray *array, GSFormatVersion format, NSError **error);

// compute byte count as string size without terminating \0
#define GSDataAppendString(DATA, STRING) \
	CFDataAppendBytes(DATA, (UInt8 *)("" STRING ""), sizeof(STRING) - 1);

// BOOL GSWritePropertyListToFile(id object, NSString *path, BOOL atomically);

// BOOL GSWritePropertyListToURL(id plist, NSURL *url, BOOL atomically);
